# Contains external methods used as workflow scripts

from Products.CMFCore.utils import getToolByName
from DateTime import DateTime

def postJobPosting(self, state_change):
    """Set the effective date"""
    context = state_change.object
    context.setEffectiveDate(DateTime())
    
def retractJobPosting(self, state_change):
    """Set effective date to None"""    
    context = state_change.object
    context.setEffectiveDate(None)
    
def postJobResponse(self, state_change):
    """Make the owner of the parent posting the owner of the response"""
    context = state_change.object
    utils = getToolByName(context, 'plone_utils')
    owner = context.aq_inner.aq_parent.Creator()
    utils.changeOwnershipOf(context, owner)
    # Note: We leave Creator() intact, to keep track of who's already responded