from Globals import package_home

from Products.CMFCore import utils
from Products.CMFCore import DirectoryView

from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

from config import product_globals, PROJECTNAME
from permissions import DEFAULT_ADD_CONTENT_PERMISSION, ADD_CONTENT_PERMISSIONS

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/PloneJobBoard', product_globals)

import validators

def initialize(context):

    from content import category
    from content import board
    from content import posting
    from content import response
    from content import security
    
    contentTypes, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    # Default add permission is "add postings". We will set the permission
    # on boards and responses separately

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = contentTypes,
        permission         = DEFAULT_ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    # give it some extra permissions to control them on a per class limit
    for i in range(0, len(contentTypes)):
        klassname = contentTypes[i].__name__
        if not klassname in ADD_CONTENT_PERMISSIONS:
            continue

        context.registerClass(meta_type   = ftis[i]['meta_type'],
                              constructors= (constructors[i],),
                              permission  = ADD_CONTENT_PERMISSIONS[klassname])
