__author__  = 'Martin Aspeli <optilude@gmx.net>'
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import *

from Products.PloneJobBoard import permissions

SecuritySchema = Schema((
    LinesField('permittedRoles',
        enforceVocabulary = True,
        multiValued = True,
        vocabulary = 'getAvailableRoles',
        index = ':schema',
        widget = MultiSelectionWidget(
            description = """Please select which user roles may post to this section. """ \
                          """Note that if you select nothing, there will be no role restrictions. """ \
                          """To deactivate the section completely, use the 'state' drop-down to de-active it.""",
            description_msgid = 'PloneJobBoard_help_permittedRoles',
            i18n_domain = 'PloneJobBoard',
            label = "Permitted roles",
            label_msgid = 'PloneJobBoard_label_permittedRoles',
        ),
    ),
))

class JobBoardPermissionsMixin:
    """Mixin class providing the ability to restrict posting to a job
    board to certain roles.
    """
    security = ClassSecurityInfo()

    security.declareProtected(permissions.ModifyPortalContent, 'getAvailableRoles')
    def getAvailableRoles(self):
        """Get a DisplayList of the available roles to restrict posting to.
        """
        lst = DisplayList()
        for role in self.validRoles():
            lst.add(role, role)
        return lst
